import Web3 from 'web3';
import { PastEventOptions } from 'web3-eth-contract';
import { GeneralFunctions, ISpecialTx } from '@energyweb/utils-general';
export interface TransferSingleEvent {
    _id: string;
    _operator: string;
    _from: string;
    _to: string;
    _value: string;
}
export interface ClaimSingleEvent {
    _claimIssuer: string;
    _claimSubject: string;
    _topic: string;
    _id: string;
    _value: string;
    _claimData: string;
}
export declare class Registry extends GeneralFunctions {
    web3: Web3;
    constructor(web3: Web3, address?: string);
    initialize(txParams: ISpecialTx): Promise<import("web3-core").TransactionReceipt>;
    getAllEvents(eventFilter?: PastEventOptions): Promise<import("web3-eth-contract").EventData[]>;
    getAllTransferSingleEvents(eventFilter?: PastEventOptions): Promise<import("web3-eth-contract").EventData[]>;
    getAllTransferBatchEvents(eventFilter?: PastEventOptions): Promise<import("web3-eth-contract").EventData[]>;
    getAllClaimSingleEvents(eventFilter?: PastEventOptions): Promise<import("web3-eth-contract").EventData[]>;
    getAllClaimBatchEvents(eventFilter?: PastEventOptions): Promise<import("web3-eth-contract").EventData[]>;
    getAllIssuanceSingleEvents(eventFilter?: PastEventOptions): Promise<import("web3-eth-contract").EventData[]>;
    balanceOf(_tokenOwner: string, _id: number, txParams?: ISpecialTx): Promise<any>;
    claimedBalanceOf(_tokenOwner: string, _id: number, txParams?: ISpecialTx): Promise<any>;
    getCertificate(_certificateId: number, txParams?: ISpecialTx): Promise<any>;
    safeTransferFrom(_from: string, _to: string, _certificateId: number, _value: number, _data: number[], txParams?: ISpecialTx): Promise<import("web3-core").TransactionReceipt>;
    safeTransferAndClaimFrom(_from: string, _to: string, _certificateId: number, _value: number, _data: number[], _claimData: number[], txParams?: ISpecialTx): Promise<import("web3-core").TransactionReceipt>;
    safeBatchTransferAndClaimFrom(_from: string, _to: string, _ids: number[], _values: number[], _data: number[], _claimData: number[][], txParams?: ISpecialTx): Promise<import("web3-core").TransactionReceipt>;
    safeBatchTransferFrom(_from: string, _to: string, _ids: number[], _values: number[], _data: number[], txParams?: ISpecialTx): Promise<import("web3-core").TransactionReceipt>;
    totalSupply(txParams?: ISpecialTx): Promise<any>;
    issue(_to: string, _validityData: any, _topic: number, _value: number, _data: any, txParams?: ISpecialTx): Promise<import("web3-core").TransactionReceipt>;
}
